package com.application.GUI.PopUpWindows;

import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;
import javafx.stage.Modality;
import javafx.stage.Stage;

import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Arrays;

import static com.application.DB.Account_handler.getAccount;

public class LoginPopup {

    public static void login(){

        Stage window = new Stage();
        window.initModality(Modality.APPLICATION_MODAL);
        window.setTitle("Login window");

        Label userNameLabel = new Label("Username:");
        Label passwordLabel = new Label("Password:");

        TextField userNameTextField = new TextField();
        PasswordField passwordTextField = new PasswordField();


        Button loginButton = new Button("Login");
        Button closeButton = new Button("Close");

        loginButton.setOnAction(event -> {

            try {
                MessageDigest messageDigest = MessageDigest.getInstance("SHA-512");

                assert messageDigest != null;
                messageDigest.update(passwordTextField.getText().getBytes(StandardCharsets.UTF_8));

                byte[] hashedPassword = messageDigest.digest();

                StringBuilder hashedPasswordString = new StringBuilder();

                for (byte b: hashedPassword) {
                    hashedPasswordString.append(String.format("%02x",b));
                }

                getAccount(userNameTextField.getText(),hashedPasswordString.toString());

            } catch (Exception e) {
                e.printStackTrace();
            }

        });
        closeButton.setOnAction(event -> window.close());


        VBox layout = new VBox(10);
        layout.setAlignment(Pos.CENTER);
        layout.getChildren().addAll(userNameLabel, userNameTextField, passwordLabel, passwordTextField, loginButton, closeButton);

        Scene scene = new Scene(layout, 500, 300);
        scene.getStylesheets().add(InputPopup.class.getResource("/com.application/CSS/styleSheet.css").toExternalForm());
        window.setScene(scene);
        window.showAndWait();
    }
}
